//*****************************************************************************
//*
//*		
//*		ChildView.cpp : Implementatierung der Klasse CChildView
//*		
//*
//*****************************************************************************
#include	"StdAfx.h"
#include 	"Equilizer.h"
#include 	"ChildView.h"
#include 	"..\BandPass.h"
#include 	"..\FirFilter.h"
#include 	"..\WavClass.h"
#include 	"..\WinAudio.h"
#include 	<math.h>

	
#ifdef		_DEBUG
#define new  DEBUG_NEW
#undef		 THIS_FILE
static char  THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_WM_VSCROLL()
	ON_WM_DESTROY()
	ON_COMMAND(ID_PLAY,OnPlay)
	ON_COMMAND(ID_STOP,OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

#define		PI			3.14159265358979

CFirFilter	equilizer;
WavClass	wave;


//*****************************************************************************
//*
//*		Konstruktor
//*
//*****************************************************************************
CChildView::CChildView()
{
double	freq[]={ 88.4 , 176.8 , 353.6 , 707.1 , 1414.2 , 2828.4 , 5656.8 ,11313.7 };


	memset(slider_pos,0,sizeof(slider_pos));
	BandPassInit(freq,8,44100.0);
}



//*****************************************************************************
//*
//*		Destruktor
//*
//*****************************************************************************
CChildView::~CChildView()
{
}


//*****************************************************************************
//*
//*		PreCreateWindow
//*
//*****************************************************************************
BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
int ok;

	   ok=AudioOpen(44100,16,2,0x4000);
	if(ok)
		{
		::MessageBox(0,"Kann Audio-Treiber nicht ffnen","Fehler",MB_OK|MB_ICONERROR);
		}

	   ok=wave.Open("Test.wav");
	if(ok)
		{
		::MessageBox(0,"Wave Datei \"Test.wav\" nicht ffnen","Fehler",MB_OK|MB_ICONERROR);
		}

	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}


//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
void CChildView::OnPaint() 
{
int		x;
double	hz=62.5;
char	text[16];

	CPaintDC dc(this); // Gertekontext zum Zeichnen
	
	for(x=0;x<10;x++)
		{	
		if(hz<1000)
				sprintf(text,"%.1f Hz",hz);
		else	sprintf(text,"%.1f kHz",hz/1000.0);
		if(x==9)sprintf(text,"Volume");
		
		dc.TextOut(x*70+30,75,text,strlen(text));
		hz*=2;
		}

	
}



//*****************************************************************************
//*
//*		OnCreate
//*
//*****************************************************************************
int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
CRect	rect;
int		x;

	if (CWnd ::OnCreate(lpCreateStruct) == -1)return -1;


	for(x=0;x<10;x++)
		{	
		rect.SetRect(x*70+40,100,x*70+60,350);
		slider[x].Create(TBS_VERT|TBS_RIGHT|TBS_AUTOTICKS|WS_BORDER,rect,this,1000+x);
		slider[x].SetPos(1);
		slider[x].SetRange(-10,10);
		slider[x].SetPageSize(2);
		slider[x].SetPos(slider_pos[x]);
		slider[x].ShowWindow(SW_SHOW);
		}
	

	SetEquilizer();


	return 0;
}


//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CChildView::OnDestroy() 
{
	CWnd ::OnDestroy();
	AudioClose();
	wave.Close();
	
}

//*****************************************************************************
//*
//*		OnPlay
//*
//*****************************************************************************
void CChildView::OnPlay()
{
int ok;

   ok=AudioWriteProcThread(CChildView::ReadFromWave,&wave);
if(ok)
	{
	MessageBox("Fehler beim Abspilen");
	}

}


//*****************************************************************************
//*
//*		OnStop
//*
//*****************************************************************************
void CChildView::OnStop()
{
AudioStop();
}

//*****************************************************************************
//*
//*		OnVScroll
//*
//*****************************************************************************
void CChildView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
int id,pos;

	CWnd ::OnVScroll(nSBCode, nPos, pScrollBar);


	id=GetWindowLong(pScrollBar->m_hWnd,GWL_ID);

	if(id>=1000 && id<=1009)
		{
		id-=1000;
		pos=slider[id].GetPos();

		if(pos!=slider_pos[id])
			{
			slider_pos[id]=pos;
			SetEquilizer();
			}
		}	
}

//*****************************************************************************
//*
//*		SetEquilizer
//*
//*****************************************************************************
void CChildView::SetEquilizer()
{
/*
double	freq[1024],f,f1,n,v,p1,p2,log2;
int		x,pos;


	log2 = log(2);
	for(x=0;x<1024;x++)
		{
		f=(double)x*(22050.0/1024.0);
		n=log(f*0.016+0.00001)/log2-1.0;
		f1= 62.5*pow(2.0,n+1.0);
		if(n<-1.0)n=-1.0;
		if(n>=9.0)n= 8.99999;
		
		pos=(int)n;
		n -=(double)pos;

		if(pos<0)
				p1 = (double)slider_pos[ 0   ]*-0.1+1.0;
		else	p1 = (double)slider_pos[pos  ]*-0.1+1.0;
				p2 = (double)slider_pos[pos+1]*-0.1+1.0;

		v  = cos(PI*n)*0.5+0.5;
		v *= p1-p2;		
		v += p2; 

		freq[x]= v;		
		}

	equilizer.SetFreq(freq,1024,128);
	equilizer.Reset();
	*/


int		eq;
double	vol[9],mvol;


	mvol = (double)slider_pos[9]*-0.1+1.0;

	for(eq=0;eq<9;eq++)
		{
		vol[eq]  = (double)slider_pos[eq]*-0.1+1.0;
		vol[eq] *= mvol;
		}
	
	BandPassVolume(vol,0);
	BandPassVolume(vol,1);

}

//*****************************************************************************
//*
//*		ReadFromWave
//*
//*****************************************************************************
//	Liest die Audiodaten aus einer Wavedatei
//	Param	: Zeiger auf die Wave-Klasse
//	Buffer	: Zeiger auf Aufnahmedaten
//	Count	: Gre der Aufnahmedaten in Byte
int _cdecl CChildView::ReadFromWave(void* Param,void* Buffer,int Count)
{
WavClass   *wave=(WavClass*)Param;
static		short	mem[4096];
int			pos=0,anz;

	/*
	while(pos<Count)
		{
		   anz=Count;
		if(anz>sizeof(mem))anz=sizeof(mem);
		
		wave->Read(mem,anz);

		equilizer.Filter((short*)((char*)Buffer+pos  ),mem  ,anz/4,2);
		equilizer.Filter((short*)((char*)Buffer+pos+2),mem+1,anz/4,2);
		
		pos+=anz;
		}
	*/
	

	while(pos<Count)
		{
		   anz=Count;
		if(anz>sizeof(mem))anz=sizeof(mem);
		
		wave->Read(mem,anz);

		BandPass((short*)((char*)Buffer+pos),mem,anz/2,2);


		pos+=anz;
		}
	

return pos;
}

