//*****************************************************************************
//*
//*		Das ist ein Demo-Programm das zeigt wie man Audio-Sampel abspielt
//*		Die Samples werden dabei aus eine Wave-Datei geladen
//*
//*		WinAudio.c		ist der Treiber fr das Abspielen
//*		WavClass.cpp	ist die Klasse fr die Wave-Datei
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#include	<conio.h>
#include	<stdio.h>
#include	<windows.h>
#include	"WavClass.h"
#include	"WinAudio.h"



//*****************************************************************************
//*
//*		ReadFromWave
//*
//*****************************************************************************
//	Liest die Audiodaten aus einer Wavedatei
//	Diese funktion wird im Hintergrund von einem Thread aufgerufen
//	Param	: Zeiger auf die Wave-Klasse
//	Buffer	: Zeiger auf Abspieldaten
//	Count	: Gre der Abspieldaten in Byte
int _cdecl ReadFromWave(void* Param,void* Buffer,int Count)
{
WavClass	*wave=(WavClass*)Param;
int			 c;
char		*b=(char*)Buffer;


	c=wave->Read(Buffer,Count);

return c;
}


//*****************************************************************************
//*
//*		main
//*
//*****************************************************************************
int main(int argc,char **argv)
{
int			ok,z,x;
WavClass	wave;
int			volume;



	if(wave.Open("Test.wav"))
		{
		printf("\nFehler beim Oeffnen von 'Test.wav' !\nWeiter mit Taste\n");
		getch();
		return -1;
		}


	printf("\nAbspiel Lautstaerke einstellen ? ( 0-9 (0=leise 9=laut ESC=Abbruch )");

	for(;;)
		{
		z=getch();
		if(z>='0' && z<='9'){volume=6000*(z-'0');break;}
		if(z==27 )return 0;
		}


//******************** Abspiel-Treiber ffnen *********************************
int		freq,bits,channels;

	freq     =  wave.Rate();
	bits     =  wave.Bits();
	channels =  wave.Channels();


	   ok=AudioOpen(freq,bits,channels,0x4000);
	if(ok)
		{
		printf("\nFehler beim Oeffnen des Audio-Device!\nWeiter mit Taste\n");
		getch();
		return -1;
		}

//******************** Abspiel-Lautstrke whlen *****************************

	   ok=AudioSetVolume(volume);
	if(ok<0)
		{
		AudioClose();
		printf("\nFehler beim Einstellen der Lautstaerke!\nWeiter mit Taste\n");
		getch();
		return -1;
		}

//******************** Abspiel-Thread starten *********************************

	   ok=AudioWriteProcThread(ReadFromWave,&wave);
	if(ok)
		{
		wave.Close();
		AudioClose();
		printf("\nFehler beim Starten des Threads!\nWeiter mit Taste\n");
		getch();
		return -1;
		}

//******************** Warte 10 Sekunden **************************************
int pause=1;


	printf("\nSpiele 10 Sekunden von 'Test.wav'  ( P=Pause ESC=Abbruch )");

	for(x=0;x<10;x++)
		{
		if(_kbhit())
			{
			z=getch();
			if(z==27){AudioStop();break;}
			if(z=='P' || z=='p'){AudioPause(pause);pause^=1;}
			}

		printf("\nSekunde %2i %s",x,(!pause)? "Pause":"");
		Sleep(1000);
		if(AudioIsReady())break;
		}

//*****************************************************************************

	AudioClose();
	wave.Close();

	printf("\nDas Abspielen ist beendet\nWeiter mit Taste\n",z);
	getch();


return 0;
}
