//*****************************************************************************
//*
//*		Das ist ein Demo-Programm das zeigt wie man Audio-Sampel aufnimmt
//*		und in einer Wave-Datei speichert
//*
//*		WinRecord.c		ist der Treiber fr die Aufnahme
//*		WavClass.cpp	ist die Klasse fr die Wave-Datei
//*
//*****************************************************************************
#include	<conio.h>
#include	<stdio.h>
#include	<windows.h>
#include	"WavClass.h"
#include	"WinRecord.h"




//*****************************************************************************
//*
//*		WriteToWave
//*
//*****************************************************************************
//	Speichert die Aufnamedaten in einer Wavedatei
//	Diese funktion wird im Hintergrund von einem Thread aufgerufen
//	Param	: Zeiger auf die Wave-Klasse
//	Buffer	: Zeiger auf Aufnahmedaten
//	Count	: Gre der Aufnahmedaten in Byte
int _cdecl WriteToWave(void* Param,void* Buffer,int Count)
{
WavClass	*wave=(WavClass*)Param;

return wave->Write(Buffer,Count);
}


//*****************************************************************************
//*
//*		main
//*
//*****************************************************************************
int main(int argc,char **argv)
{
int		anz,ok,z;
int		volume=32000;
int		input=REC_MIC;



	printf("\nVorhandene Aufnahmne Quellen:\n"); 
	ok=RecordOpen(44100,16,2,0x4000);
	anz=RecordScanInputs();
	for(z=0;z<anz;z++)
		{
		printf("\n %c)  %s",z+'A',RecordGetInputName(z,0));
		}

	RecordClose();

//******************** Aufnahme-Quelle whlen *********************************

	printf("\n\nVon wo aufnehmen ? ( 1=Microfon 2=CD 3=LineIn 4=WaveOut oder A..%c  ESC=Abbruch)",'A'+anz-1);

	for(;;) 
		{
		z=getch();
		if(z=='1' || z=='1'){input=REC_MIC;		break;}
		if(z=='2' || z=='2'){input=REC_CD;		break;}
		if(z=='3' || z=='3'){input=REC_AUX;		break;}
		if(z=='4' || z=='4'){input=REC_ANALOG;	break;}
		if(z>='A' && z< 'A'+anz){input=z-'A';	break;}
		if(z>='a' && z< 'a'+anz){input=z-'a';	break;}
		if(z==27 )return 0;
		}


	printf("\nAufnahme Lautstaerke einstellen ? ( 0-9 (0=leise 9=laut ESC=Abbruch )");

	for(;;) 
		{
		z=getch();
		if(z>='0' && z<='9'){volume=6000*(z-'0');break;}
		if(z==27 )return 0;
		}

//******************** Aufnahme-Treiber ffnen ********************************
							   
	   ok=RecordOpen(44100,16,2,0x4000);
	if(ok)
		{
		printf("\nFehler beim Oeffnen des Record-Device!\nWeiter mit Taste\n");
		getch();
		return -1;
		}

//******************** Aufnahme-Eingang whlen ********************************

	   ok=RecordSetInputEnable(input);
	if(ok)
		{
		RecordClose();
		printf("\nFehler beim Auswaehlen des Eingangs!\nWeiter mit Taste\n");
		getch();
		return -1;
		}

//******************** Aufnahme-Lautstrke whlen *****************************

	   ok=RecordSetInputVolume(input,volume);
	if(ok<0)
		{
		RecordClose();
		printf("\nFehler beim Einstellen der Aufnahmelautstaerke!\nWeiter mit Taste\n");
		getch();
		return -1;
		}

//******************** Wave-Datei erzeugen ************************************
WavClass	wave;

	   wave.SetMode(44100,4,1);
	if(wave.Create("Test1.wav"))
		{
		RecordClose();
		printf("\nFehler beim Erstellen von 'Test1.wav' !\nWeiter mit Taste\n");
		getch();
		return -1;
		}

//******************** Aufnahme-Thread starten ********************************

	   ok=RecordReadProcThread(WriteToWave,&wave);
	if(ok)
		{
		wave.Close();
		RecordClose();
		printf("\nFehler beim Starten des Threads!\nWeiter mit Taste\n");
		getch();
		return -1;
		}

//******************** Warte 10 Sekunden **************************************

	printf("\nSpeichere 10 Sekunden in 'Test1.wav'  (Abbruch mit ESC)");

	for(z=0;z<10;z++)
		{
		if(_kbhit())
			{
			z=getch();
			if(z==27)break;
			}

		printf("\nSekunde %2i von 10",z);
		Sleep(1000);
		}

//*****************************************************************************

	RecordClose();
	wave.Close();

	printf("\nDie Aufnahmen wurde erfogreich beendet\nWeiter mit Taste\n");
	getch();


return 0;
}