//*****************************************************************************
//*
//*		A audio driver for windows
//*
//*		Writte by Anton Zechen (C)2000
//*
//*****************************************************************************
//
//	(C) Copyright Anton Zechner 2007
//
#ifndef	WIN_RECORD_H_INCLUDE
#define WIN_RECORD_H_INCLUDE

#include	<stdio.h>


#ifdef	__cplusplus
extern	"C" {
#endif

#define 	REC_MIC			-1
#define 	REC_CD  		-2
#define 	REC_WAVEOUT		-3
#define 	REC_ANALOG		-4
#define 	REC_AUX  		-5
#define 	REC_DIGITAL  	-6
#define 	REC_LINE  		-7
#define 	REC_PCSPEAKER	-8
#define 	REC_SYNTHESIZER -9
#define 	REC_TELEPHONE	-10


typedef	int(_cdecl *RecWrProc)(void*,void*,int);


extern	int   RecordOpen(	unsigned  Freq,
							unsigned  Bits,
							unsigned  Channels,
							unsigned  BufferSize);				/* Starts recording       */
extern	int   RecordClose();									/* Close device           */
extern	int   RecordStop();										/* Stops recording		  */
extern	int   RecordScanInputs();								/* Scann all mixer inputs */
extern	int   RecordGetInputEnable(int Type);					/* Get the state  of a mixer line   */
extern	int   RecordSetInputEnable(int Type);					/* Set the active mixer line        */
extern	int   RecordGetInputVolume(int Type);					/* Get the volume of a mixer line   */
extern	int   RecordSetInputVolume(int Type,unsigned Volume);	/* Set the volume of a mixer line   */
extern	int	  RecordIsOpen();									/* Get the open state of the driver */
extern	char *RecordGetInputName  (int Type,int ShortName);		/* Get the Name of a input */
extern	int	  RecordInfo(unsigned *Freq,unsigned *Bits,unsigned *Channels,unsigned  *BufferSize ); /*	Get infos of the opened record input */

extern	int   RecordReadIo(int Handle);							/* Write data to file     */
extern	int   RecordReadFile(FILE *File);						/* Write data to file     */
extern	int   RecordReadProc(RecWrProc Proc,void *Param);		/* Write data to funktion */
extern	int   RecordReadIoThread(int Handle);					/* Starts a thread for write to a file     */
extern	int   RecordReadFileThread(FILE *File);					/* Starts a thread for write to a file     */
extern	int   RecordReadProcThread(RecWrProc Proc,void *Param);	/* Starts a thread for write to a funktion */


#ifdef	__cplusplus
		}
#endif

#endif
